﻿Imports System
Imports System.IO
Imports System.Data.OleDb
Imports System.Data.Odbc
Imports System.Data.Common
Imports System.Data.SqlClient
Imports System.Windows.Forms
Imports System.Drawing
Imports System.Math
Imports NM_Ahnen
Imports NM_Ahnen.cls_00_Def
Imports NM_Ahnen.cls_02_DB_Neu
Imports NM_Ahnen.cls_04_Util
Imports NM_Ahnen.cls_05_Strukturen
Imports NM_Ahnen.NM_Ahnen_Search

Class Cls_02_DB

    REM **************************************************************
    REM *  Laden der Ini-Datei (Pfadangabe)                          *
    REM **************************************************************
    Public Shared Sub Load_INI()
        Dim fs As FileStream
        str_NM99 = ""
        str_ini = "NM_Ahnen.ini"
        Try
            fs = New FileStream(str_ini, FileMode.Open)
        Catch ex As IOException
            MsgBox(ex.Message)
            int_Total_Error = 1
            Exit Sub
        End Try

        Dim sw As StreamReader = New StreamReader(fs)
        Dim ze As String
        Dim int_N01 As Integer
        Dim int_N02 As Integer
        Dim int_N03 As Integer
        str_DBPfad1 = ""
        str_DBPfad2 = ""
        str_DBName = ""
        Try
            Do Until sw.Peek() = -1
                ze = sw.ReadLine()
                If Mid(ze, 1, 7) = "[NM01]=" Then str_DBPfad1 = Mid(ze, 8, Len(ze) - 7) : int_N01 = 1
                If Mid(ze, 1, 7) = "[NM02]=" Then
                    str_DBPfad2 = Mid(ze, 8, Len(ze) - 7) : int_N02 = 1
                    str_DBName = Mid(ze, 8, Len(ze) - 7) : int_N03 = 1
                End If
                'If Mid(ze, 1, 7) = "[NM03]=" Then str_DBName = Mid(ze, 8, Len(ze) - 7) : int_N03 = 1
            Loop
            sw.Close()

            str_NM99 = str_DBPfad1 + "\" + str_DBPfad2
            str_Directory = str_NM99
            str_PicDirectory = str_NM99 + "\Pic\"

        Catch ex As Exception
            MsgBox(ex.Message)
            str_ini = ""
        End Try

        If str_DBPfad1 = "" Or str_DBPfad2 = "" Or str_DBName = "" Then
            response = MessageBox.Show("Schwerer Fehler", "DB nicht vorhanden - Neue DB anlegen?", MessageBoxButtons.YesNo, MessageBoxIcon.Question, MessageBoxDefaultButton.Button2)
            If response = MsgBoxResult.Yes Then
                Call DB_Create()
                Exit Sub
            Else
                Application.Exit()
            End If
        End If

    End Sub

    REM **************************************************************
    REM *  Open-Routine für die DB                                   *
    REM **************************************************************
    Public Shared Sub Open_DB()

        If con.State = ConnectionState.Open Then con.Close()
        dbProv = String.Format("Provider=Microsoft.ACE.OLEDB.12.0; Data Source={0}\" + str_DBName + ".accdb; Jet OLEDB:Database Password=NM;", str_NM99)
        con.ConnectionString = dbProv
        mySelect.Connection = con
        mySelect1.Connection = con
        Try
            con.Open()
        Catch ex As Exception
            MessageBox.Show(ex.Message, "Beim Öffnen der Datenbank ist ein Fehler aufgetreten.")
            int_Total_Error = 1
        End Try
        NM_Ahnen.Stat_DB.Text = str_DBName


    End Sub

    REM *****************************************************************
    REM *  Laden der Parameterwerte                                     *
    REM *****************************************************************
    Public Shared Sub Open_Para()

        Call Tab_Para()
        Call ID_Tab_Fuell()
        Call ID_TabBeruf_Fuell()
        Call Tab_Datumsart()
        Call Tab_Altersgrenzen()
        Call Tab_Konfessionen()
        Call Tab_Felder()
        Call Tab_Orte()
        Call Tab_Namen()
        Call Tab_Vornamen()
        Call Tab_Tod()
        Call Tab_Beruf()

        Call DB_Struktur()
        Call Tab_FeldBez()

    End Sub

    REM **************************************************************
    REM *  Füllen der ID-Tabelle für Blätter-Modus                   *
    REM **************************************************************
    Public Shared Sub ID_Tab_Fuell()

        Dim int_Anz As Integer = GetNumberOfRecords(con, "t01_Person")
        Dim int_i5 As Integer = 0
        Dim reader As OleDbDataReader
        int_Ged_Anz = int_Anz
        ReDim lng_ID(int_Anz)

        NM_Ahnen.Stat_Anzahl.Text = "Anzahl: " & int_Anz.ToString

        mySelect.Connection = con
        mySelect.CommandText = "select * from t01_Person"

        reader = mySelect.ExecuteReader

        Do While reader.Read()
            lng_ID(int_i5) = reader.Item("t01_ID")
            int_i5 += 1
        Loop
        reader.Close()

        dbl_Max = int_i5
        int_Zeig_Pers = 0

    End Sub

    REM **************************************************************
    REM *  Füllen der Tabelle Datumsarten für Combo-Boxen            *
    REM **************************************************************
    Public Shared Sub Tab_Para()

        int_AnzKonf = GetNumberOfRecordsTyp(con, "a01_Para", " where a01_Typ = 1")
        Dim reader As OleDbDataReader
        ReDim str_Para_Konf_Bez(int_AnzKonf)
        ReDim str_Para_Konf_Text(int_AnzKonf)

        mySelect.Connection = con
        mySelect.CommandText = "select * from a01_Para where a01_Typ = 1"

        reader = mySelect.ExecuteReader

        Do While reader.Read()
            int_Sprache = reader.Item("a01_Sprache")
            str_DokPfad = reader.Item("a01_DokPfad")
        Loop
        reader.Close()

    End Sub

    REM **************************************************************
    REM *  Füllen der Tabelle Datumsarten für Combo-Boxen            *
    REM **************************************************************
    Public Shared Sub Tab_Datumsart()

        int_AnzPara = GetNumberOfRecordsTyp(con, "a06_Datumstyp", " where a06_Typ = 1")
        Dim reader As OleDbDataReader
        Dim int_i5 As Integer = 1
        ReDim str_Para_DA(int_AnzPara)

        mySelect.Connection = con
        mySelect.CommandText = "select * from a06_Datumstyp where a06_Typ = 1"

        reader = mySelect.ExecuteReader

        Do While reader.Read()
            int_i5 = reader.Item("a06_lfd")
            str_Para_DA(int_i5) = reader.Item("a06_Text")
            scA_Date.Add(str_Para_DA(int_i5))

        Loop

        reader.Close()

        With NM_Ahnen
            .cbx_10_GDat.Items.Clear()
            .cbx_10_SDat.Items.Clear()
            .cbx_11_TDat_Art.Items.Clear()
            .cbx_11_TDat_Art.Items.Clear()
            .cbx_12_BDat_Art.Items.Clear()
            .cbx_13_EDat1_Art.Items.Clear()
            .cbx_13_EDat2_Art.Items.Clear()
            .cbx_13_EDat3_Art.Items.Clear()

            .cbx_10_GDat.Items.Add("")
            .cbx_10_SDat.Items.Add("")
            .cbx_11_TDat_Art.Items.Add("")
            .cbx_11_FDat_Art.Items.Add("")
            .cbx_12_BDat_Art.Items.Add("")
            .cbx_13_EDat1_Art.Items.Add("")
            .cbx_13_EDat2_Art.Items.Add("")
            .cbx_13_EDat3_Art.Items.Add("")

            For int_i5 = 1 To int_AnzPara
                .cbx_10_GDat.Items.Add(str_Para_DA(int_i5))
                .cbx_10_SDat.Items.Add(str_Para_DA(int_i5))
                .cbx_11_TDat_Art.Items.Add(str_Para_DA(int_i5))
                .cbx_11_FDat_Art.Items.Add(str_Para_DA(int_i5))
                .cbx_12_BDat_Art.Items.Add(str_Para_DA(int_i5))
                .cbx_13_EDat1_Art.Items.Add(str_Para_DA(int_i5))
                .cbx_13_EDat2_Art.Items.Add(str_Para_DA(int_i5))
                .cbx_13_EDat3_Art.Items.Add(str_Para_DA(int_i5))
            Next
        End With

    End Sub

    REM **************************************************************
    REM *  Füllen der Felder Altersgrenzen                           *
    REM **************************************************************
    Public Shared Sub Tab_Altersgrenzen()

        Dim reader As OleDbDataReader
        mySelect.Connection = con
        mySelect.CommandText = "select * from a02_Altersgrenzen where a02_ID = 1"

        reader = mySelect.ExecuteReader

        Do While reader.Read()
            int_Delta_Vater_Min = reader.Item("a02_Vater_Min")
            int_Delta_Vater_Max = reader.Item("a02_Vater_Max")
            int_Delta_Mutter_Min = reader.Item("a02_Mutter_Min")
            int_Delta_Mutter_Max = reader.Item("a02_Mutter_Max")
            int_Delta_Ehe_Min = reader.Item("a02_Ehe_Min")
            int_Delta_Ehe_Max = reader.Item("a02_Ehe_Max")
            int_Delta_Pate_Min = reader.Item("a02_Pate_Min")
            int_Delta_Pate_Max = reader.Item("a02_Pate_Max")
            int_Delta_Zeuge_Min = reader.Item("a02_Zeuge_Min")
            int_Delta_Zeuge_Max = reader.Item("a02_Zeuge_Max")
        Loop
        reader.Close()

    End Sub

    REM **************************************************************
    REM *  Füllen der Tabelle Konfessionen für Combo-Boxen           *
    REM **************************************************************
    Public Shared Sub Tab_Namen()

        int_AnzNam1 = GetNumberOfRecordsTyp(con, "a07_Namen", " where a07_Typ = 1")
        Dim reader As OleDbDataReader
        Dim int_i5 As Integer = 0
        ReDim str_Para_Nam1_Text(int_AnzNam1)
        ReDim int_Para_Nam1_Nr(int_AnzNam1)

        mySelect.Connection = con
        mySelect.CommandText = "select * from a07_Namen where a07_Typ = 1"

        reader = mySelect.ExecuteReader

        Do While reader.Read()
            int_i5 += 1
            str_Para_Nam1_Text(int_i5) = reader.Item("a07_Text")
            int_Para_Nam1_Nr(int_i5) = reader.Item("a07_lfd")
            'scA_Nam1.Add(str_Para_Nam1_Text(int_i5))

        Loop
        reader.Close()

    End Sub

    REM **************************************************************
    REM *  Füllen der Tabelle Vornamen für Combo-Boxen               *
    REM **************************************************************
    Public Shared Sub Tab_Vornamen()

        int_AnzNam2 = GetNumberOfRecordsTyp(con, "a07_Namen", " where a07_Typ = 2")
        Dim reader As OleDbDataReader
        Dim int_i5 As Integer = 0
        ReDim str_Para_Nam2_Text(int_AnzNam2)
        ReDim int_Para_Nam2_Nr(int_AnzNam2)

        mySelect.Connection = con
        mySelect.CommandText = "select * from a07_Namen where a07_Typ = 2"

        reader = mySelect.ExecuteReader

        Do While reader.Read()
            int_i5 += 1
            str_Para_Nam2_Text(int_i5) = reader.Item("a07_Text")
            int_Para_Nam2_Nr(int_i5) = reader.Item("a07_lfd")
            'scA_Nam2.Add(str_Para_Nam2_Text(int_i5))

        Loop
        reader.Close()

    End Sub

    REM **************************************************************
    REM *  Füllen der Tabelle Konfessionen für Combo-Boxen           *
    REM **************************************************************
    Public Shared Sub Tab_Konfessionen()

        int_AnzKonf = GetNumberOfRecordsTyp(con, "a03_Konfessionen", " where a03_Typ = 1")
        Dim reader As OleDbDataReader
        Dim int_i5 As Integer
        ReDim str_Para_Konf_Bez(int_AnzKonf)
        ReDim str_Para_Konf_Text(int_AnzKonf)

        mySelect.Connection = con
        mySelect.CommandText = "select * from a03_Konfessionen where a03_Typ = 1"

        reader = mySelect.ExecuteReader

        Do While reader.Read()
            int_i5 = reader.Item("a03_lfd")
            str_Para_Konf_Bez(int_i5) = reader.Item("a03_Kurz")
            str_Para_Konf_Text(int_i5) = reader.Item("a03_Lang")
            scA_Konf.Add(str_Para_Konf_Bez(int_i5))
            NM_Ahnen.cbx_11_Konf.Items.Add(str_Para_Konf_Bez(int_i5))
        Loop
        reader.Close()

    End Sub


    REM **************************************************************
    REM *  Füllen der Tabelle Orte für Combo-Boxen                   *
    REM **************************************************************
    Public Shared Sub Tab_Orte()

        int_AnzOrte = GetNumberOfRecordsTyp(con, "a04_Orte", " where a04_Typ = 1")
        Dim reader As OleDbDataReader
        Dim int_i5 As Integer
        ReDim str_Para_Ort1_Bez(int_AnzOrte)
        ReDim str_Para_Ort2_Bez(int_AnzOrte)
        ReDim str_Para_Ort3_Bez(int_AnzOrte)

        mySelect.Connection = con
        mySelect.CommandText = "select * from a04_Orte where a04_Typ = 1"

        reader = mySelect.ExecuteReader

        Do While reader.Read()

            int_i5 = reader.Item("a04_lfd")
            myNull = IsDBNull(reader.Item("a04_Ort1"))
            If myNull = False Then str_Para_Ort1_Bez(int_i5) = reader.Item("a04_Ort1")
            myNull = IsDBNull(reader.Item("a04_Ort2"))
            If myNull = False Then str_Para_Ort2_Bez(int_i5) = reader.Item("a04_Ort2")
            myNull = IsDBNull(reader.Item("a04_Ort3"))
            If myNull = False Then str_Para_Ort3_Bez(int_i5) = reader.Item("a04_Ort3")

            'scA_Orte.Add(str_Para_Ort1_Bez(int_i5))
        Loop
        reader.Close()

    End Sub

    REM **************************************************************
    REM *  Füllen der Tabelle Konfessionen für Combo-Boxen           *
    REM **************************************************************
    Public Shared Sub Tab_Tod()

        int_AnzTod = GetNumberOfRecordsTyp(con, "a08_Tod", " where a08_Typ = 1")
        Dim reader As OleDbDataReader
        Dim int_i5 As Integer = 0
        ReDim str_Para_Tod_Text(int_AnzTod)
        ReDim int_Para_Tod_Nr(int_AnzTod)

        mySelect.Connection = con
        mySelect.CommandText = "select * from a08_Tod where a08_Typ = 1"

        reader = mySelect.ExecuteReader

        Do While reader.Read()
            int_i5 += 1
            str_Para_Tod_Text(int_i5) = reader.Item("a08_Text")
            int_Para_Tod_Nr(int_i5) = reader.Item("a08_lfd")
            'scA_Tod.Add(str_Para_Tod_Text(int_i5))

        Loop
        reader.Close()

    End Sub

    REM **************************************************************
    REM *  Füllen der Tabelle Berufe für Combo-Boxen                 *
    REM **************************************************************
    Public Shared Sub Tab_Beruf()

        int_AnzBeruf = GetNumberOfRecords(con, "t77_Beruf")
        Dim reader As OleDbDataReader
        Dim int_i5 As Integer = 0
        ReDim str_Para_Beruf_Text(int_AnzBeruf)

        mySelect.Connection = con
        mySelect.CommandText = "select * from t77_Beruf"

        reader = mySelect.ExecuteReader

        Do While reader.Read()
            int_i5 += 1
            str_Para_Beruf_Text(int_i5) = reader.Item("t77_Beruf")
            'scA_Beruf.Add(str_Para_Beruf_Text(int_i5))

        Loop
        reader.Close()

    End Sub

    REM **************************************************************
    REM *  Füllen der Tabelle Datumsarten für Combo-Boxen            *
    REM **************************************************************
    Public Shared Sub Tab_Felder()

        int_AnzOrte = GetNumberOfRecordsTyp(con, "a05_Felder", " where a05_Sprache = " + int_Sprache.ToString)
        Dim reader As OleDbDataReader
        Dim int_i5 As Integer
        Dim int_i6 As Integer
        ReDim str_FeldBez(8, 20)

        mySelect.Connection = con
        mySelect.CommandText = "select * from a05_Felder where a05_Sprache = " + int_Sprache.ToString

        reader = mySelect.ExecuteReader

        Do While reader.Read()

            int_i5 = reader.Item("a05_Maske") - 10
            int_i6 = reader.Item("a05_FeldNr")
            myNull = IsDBNull(reader.Item("a05_Feldbez"))
            If myNull = False Then str_FeldBez(int_i5, int_i6) = reader.Item("a05_Feldbez")

        Loop

        reader.Close()

    End Sub

    REM **************************************************************
    REM *  Füllen der Berufe-Tabelle                                 *
    REM **************************************************************
    Public Shared Sub ID_TabBeruf_Fuell()

        Dim int_Anz As Integer = GetNumberOfRecords(con, "t77_Beruf")
        Dim int_i5 As Integer = 0
        Dim reader As OleDbDataReader
        ReDim tab_Beruf_ID(int_Anz)
        ReDim tab_Beruf_Bez(int_Anz)

        mySelect.Connection = con
        mySelect.CommandText = "select * from t77_Beruf"

        reader = mySelect.ExecuteReader

        Do While reader.Read()
            tab_Beruf_ID(int_i5) = reader.Item("t77_ID")
            tab_Beruf_Bez(int_i5) = reader.Item("t77_Beruf")
            int_i5 += 1
        Loop

        reader.Close()

        dbl_Beruf_Max = int_i5

    End Sub

    REM ******************************************************************
    REM *  Function Select count(*)                                      *
    REM ******************************************************************
    Public Shared Function GetNumberOfRecords(ByVal cnn As OleDbConnection, ByVal TableName As String) As Integer

        Dim cmd As New OleDbCommand("select count(*) from " & TableName, cnn)
        Dim ret As Object = cmd.ExecuteScalar
        If ret IsNot Nothing Then
            Return CType(ret, Integer)
        Else
            Return 0
        End If

    End Function

    REM ******************************************************************
    REM *  Function Select count(*) und Where-Bedingung                  *
    REM ******************************************************************
    Public Shared Function GetNumberOfRecordsTyp(ByVal cnn As OleDbConnection, ByVal TableName As String, ByVal where As String) As Integer

        Dim cmd As New OleDbCommand("select count(*) from " & TableName & where, cnn)
        Dim ret As Object = cmd.ExecuteScalar
        If ret IsNot Nothing Then
            Return CType(ret, Integer)
        Else
            Return 0
        End If

    End Function

    REM ******************************************************************
    REM *  Select auf T01 (höchste ID)                                   *
    REM ******************************************************************
    Public Shared Sub DB_Tab_High(ByVal str_ID As String, ByVal str_TX As String)

        mySelect.Connection = con
        mySelect.CommandText = "Select MAX(" + str_ID + ") from " + str_TX
        myAdapter.SelectCommand = mySelect

        Try
            dbl_Max_ID = mySelect.ExecuteScalar
        Catch ex As Exception
            dbl_Max_ID = 0
        End Try

    End Sub

    REM ******************************************************************
    REM *  Select auf T01 (höchste laufende Nr von ID)                   *
    REM ******************************************************************
    Public Shared Sub DB_T99_LFD_High()

        mySelect.Connection = con
        mySelect.CommandText = "Select MAX(t99_LFD) from t99_Aufgabe where t99_FK_t01 = " + dbl_Max_ID.ToString
        myAdapter.SelectCommand = mySelect

        Try
            int_Max_LFD = mySelect.ExecuteScalar
        Catch ex As Exception
            int_Max_LFD = 0
        End Try

    End Sub

    REM ******************************************************************
    REM *  Gesamtselect auf einzelne Tabelle und Daten                   *
    REM *  im Grid anzeigen                                              *
    REM ******************************************************************
    Public Shared Sub DB_Sel_All()

        Dim reader As OleDbDataReader
        Dim p1 As Integer
        Dim i1 As Integer

        myDataSet.Clear()
        NM_Ahnen_Search.dgv_91_Tab.ClearSelection()

        REM *------------------------------------------------------------*
        REM *  Anpassung, wenn phonetische Suche gesetzt                 *
        REM *------------------------------------------------------------*
        'If int_Merk_Phon = 1 Then str_Search2 = "%" + str_Search1 & "%'"

        REM *------------------------------------------------------------*
        REM *  Ermitteln der Trefferzahl                                 *
        REM *------------------------------------------------------------*
        mySelect.Connection = con
        mySelect.CommandText = "select count(*) from t01_Person " & str_Where

        int_Anz = GetNumberOfRecordsTyp(con, "t01_Person", str_Where)
        NM_Ahnen_Search.Text = str_Search_Header + "   -   Selektiert: " + int_Anz.ToString

        REM *------------------------------------------------------------*
        REM *  Prüfen auf Trefferzahl                                    *
        REM *------------------------------------------------------------*
        If int_Anz = 0 Then
            MsgBox("Keine Treffer!")
            int_Total_Error = 1
            int_Merk_First = 0
            Exit Sub
        End If

        REM *------------------------------------------------------------*
        REM *  Temporär-Tabelle dimensionieren und löschen               *
        REM *------------------------------------------------------------*
        ReDim temp_ID(int_Anz)

        REM *------------------------------------------------------------*
        REM *  Select-Commando zusammensetzen                            *
        REM *------------------------------------------------------------*
        mySelect.CommandText = "select * from t01_Person " & str_Where & ""

        REM *------------------------------------------------------------*
        REM *  Reader aus Selectcommando füllen                          *
        REM *------------------------------------------------------------*
        reader = mySelect.ExecuteReader
        i1 = 0

        REM *------------------------------------------------------------*
        REM *  Gefülltes Reader-Objekt zeilenweise abarbeiten und        *
        REM *  Temp-Tabelle füllen                                       *
        REM *------------------------------------------------------------*
        Do While reader.Read()
            p1 = reader("t01_ID")
            REM *--------------------------------------------------------*
            REM *  Füllen der Temporärtabelle                            *
            REM *--------------------------------------------------------*
            temp_ID(i1) = p1
            i1 += 1
        Loop
        dbl_Tmp = i1 - 1

        REM *------------------------------------------------------------*
        REM *  Evtl. Anpassen des Selektionsergebnisses                  *
        REM *------------------------------------------------------------*
        'NM_Ahnen.tStSt7.Text = "Selektiert: " + i1.ToString

        reader.Close()

        Call BuildWork()

DB_Sel_All_900:
        int_Merk_First = 0
        Call DB_Tab_All()

    End Sub

    REM ******************************************************************
    REM *  Gesamtselect auf einzelne Tabelle und Daten                   *
    REM *  im Grid anzeigen                                              *
    REM ******************************************************************
    Public Shared Sub DB_Tab_All()

        If int_Merk_First = 0 Then Call DB_Tab_First()

        Call DB_Grid_View()
        int_Merk_Tab = 1

    End Sub

    REM ******************************************************************
    REM *  DB-Operation bei erstmaliger Grid-Anzeige                     *
    REM ******************************************************************
    Public Shared Sub DB_Tab_First()

        dbl_PosS = 0
        str_Order = " order by t01_Name, t01_Vorname, t01_GDat_Sort"

        myDataSet.Clear()
        mySelect.Connection = con
        mySelect.CommandText = "select * from t91_Person"
        If int_Merk_Where = 1 Then
            'mySelect.CommandText += str_Where1
            int_Anz = GetNumberOfRecordsTyp(con, "t91_Person", str_Where1)
            str_Sort_Folge = "Name, Vorname, GebDat."
            str_Sel_Anz = "  /  Selektiert: " + int_Anz.ToString
            NM_Ahnen_Search.Text = str_Search_Header + str_Sel_Anz + str_Sort_Folge
        End If

        mySelect.CommandText += str_Order

        NM_Ahnen_Search.dgv_91_Tab.ClearSelection()

        myAdapter.SelectCommand = mySelect
        myAdapter.Fill(myDataSet, "t91_Person")
        myDataView = New DataView(myDataSet.Tables("t91_Person"))

        int_Merk_First = 1

    End Sub

    REM ******************************************************************
    REM *  Aktuelle Daten in Grid anzeigen                               *
    REM *  Sind bereits in einer Selektion ins DataSet übertragen        *
    REM ******************************************************************
    Public Shared Sub DB_Grid_View()

        dbl_PosS = 0

        With NM_Ahnen_Search
            .dgv_91_Tab.DataSource = myDataSet
            .dgv_91_Tab.DataMember = "t91_Person"
        End With

        Call GridSpalten()

    End Sub


    REM ******************************************************************
    REM *  Erstellen Worktabelle                                         *
    REM ******************************************************************
    Public Shared Sub BuildWork()

        Dim dbl_I1 As Double
        Dim anzahl As Integer

        REM *------------------------------------------------------------*
        REM *  WorkTabelle löschen, wird neu aufgebaut                   *
        REM *------------------------------------------------------------*
        mySelect.Connection = con
        mySelect.CommandText = "delete * from t91_Person"
        Call DB_Execute()

        For dbl_I1 = 0 To dbl_Tmp

            REM *--------------------------------------------------------*
            REM *  Datensatz in Worktabelle inserten                     *
            REM *--------------------------------------------------------*
            Try
                mySelect.Connection = con
                mySelect.CommandText = "insert into t91_Person select * from t01_Person where t01_ID = " & temp_ID(dbl_I1).ToString
                anzahl = mySelect.ExecuteNonQuery()
            Catch ex As Exception
                MsgBox(ex.Message)
            End Try

        Next dbl_I1

    End Sub

    REM ******************************************************************
    REM *  DB-transaction Execute                                        *
    REM ******************************************************************
    Public Shared Sub DB_Execute()

        Try
            DB_Anz = mySelect.ExecuteNonQuery
        Catch ex As Exception
            If int_Merk_Import = 0 Then
                MsgBox(ex.Message)
            Else
                Using sw As StreamWriter = File.AppendText(str_LogFile)
                    sw.WriteLine(GM_Nr + "/ " + ex.Message)
                End Using

            End If

        End Try

    End Sub

End Class
