﻿Imports System
Imports System.IO
Imports System.Data.OleDb
Imports NM_Ahnen.cls_00_Def
Imports NM_Ahnen.cls_02_DB
Imports NM_Ahnen.cls_04_Util
Imports NM_Ahnen.cls_90_Mask_201

Public Class Cls_03_DB_Bilder

    REM **************************************************************
    REM *  Füllen der Tabelle Bilder je Person                       *
    REM **************************************************************
    Public Shared Sub Tab_Bilder()

        str_Where = " where t09_FK_t01 = " + dbl_ID.ToString + " and t09_Typ = 1"
        int_AnzPic = GetNumberOfRecordsTyp(con, "t09_Bild", str_Where)

        Dim reader As OleDbDataReader
        Dim int_i5 As Integer = 0
        ReDim str_PicBez(int_AnzPic)
        ReDim str_PicName(int_AnzPic)

        mySelect.Connection = con
        mySelect.CommandText = "select * from t09_Bild" + str_Where
        reader = mySelect.ExecuteReader

        Do While reader.Read()
            myNull = IsDBNull(reader.Item("t09_lfd"))
            If myNull = False Then int_i5 = reader.Item("t09_lfd")

            myNull = IsDBNull(reader.Item("t09_Text"))
            If myNull = False Then str_PicBez(int_i5) = reader.Item("t09_Text")

            myNull = IsDBNull(reader.Item("t09_FileName"))
            If myNull = False Then str_PicName(int_i5) = reader.Item("t09_FileName")

        Loop

        reader.Close()
        With NM_Ahnen
            .tx_01_LFD.Text = ""
            .tx_01_Bez.Text = ""
        End With

    End Sub

    REM **************************************************************
    REM *  Bildinfos in Grid laden                                   *
    REM **************************************************************
    Public Shared Sub Bilder_Load()

        Dim int_i5 As Integer
        With NM_Ahnen

            .dgv_Pictures.Rows.Clear()              ' Löschen Gridzeilen
            For int_i5 = 1 To int_AnzPic
                .dgv_Pictures.Rows.Add(int_i5.ToString, str_PicBez(int_i5), str_PicName(int_i5))
            Next
            .bt_01_PicDel.Visible = False           ' Löschenbutton ausblenden

        End With

    End Sub

    REM **************************************************************
    REM *  Bildauswahl über OpenFileDialog                           *
    REM **************************************************************
    Public Shared Sub Bild_Auswahl()

        With NM_Ahnen
            .ofd_Pic.Filter = "Bild-Dateien|*.jpg;*.tif;*.bmp"
            .ofd_Pic.InitialDirectory = str_LW_INI
            .ofd_Pic.Multiselect = False

            If .ofd_Pic.ShowDialog = DialogResult.OK Then
                myStream = .ofd_Pic.OpenFile
                str_Path_1 = .ofd_Pic.FileName
                FileName = .ofd_Pic.FileName
                Call Pfad_Ermittlung()
                myStream.Close()
                .ofd_Pic.Dispose()
                Call Datei_Exists()
                File.Copy(str_Path_1, str_Path_2)
                Call Bild_Insert()
                Call Bilder_Load()
            Else
                Exit Sub
            End If
        End With

    End Sub

    REM **************************************************************
    REM *  Neu geladenes Bild anzeigen und Bezeichnungstext fordern  *
    REM **************************************************************
    Public Shared Sub Bild_Neu()

        With NM_Ahnen

            int_AnzPic += 1
            .tx_01_LFD.Text = int_AnzPic
            .tx_01_Bez.Text = ""

        End With

    End Sub

    REM **************************************************************
    REM *  aus dem Grid angewähltes Bild markieren                   *
    REM *  dann zur Änderungsroutine 2 schalten                      *
    REM **************************************************************
    Public Shared Sub Bild_Aendern()

        Dim i10 As Integer
        With NM_Ahnen

            .tx_01_LFD.Text = .dgv_Pictures.CurrentRow.Cells(0).Value
            .tx_01_Bez.Text = .dgv_Pictures.CurrentRow.Cells(1).Value
            str_Path_2 = str_PicDirectory + .dgv_Pictures.CurrentRow.Cells(2).Value

            For i10 = 0 To (int_AnzPic - 1)
                .dgv_Pictures.Rows(i10).Cells(0).Style.BackColor = col_Grid1
                .dgv_Pictures.Rows(i10).Cells(1).Style.BackColor = col_Grid1
                .dgv_Pictures.Rows(i10).Cells(2).Style.BackColor = col_Grid1
            Next

            .dgv_Pictures.CurrentRow.Cells(0).Style.BackColor = col_Grid2
            .dgv_Pictures.CurrentRow.Cells(1).Style.BackColor = col_Grid2
            .dgv_Pictures.CurrentRow.Cells(2).Style.BackColor = col_Grid2
            .bt_01_PicDel.Visible = True

            Call Bild_Aendern_2()

        End With

    End Sub

    REM **************************************************************
    REM *  Ausgewähltes Bild laden und anzeigen                      *
    REM **************************************************************
    Public Shared Sub Bild_Aendern_2()

        With NM_Ahnen

            Dim picFileStream As New FileStream(str_Path_2, FileMode.Open, FileAccess.Read)

            Img_Pers = Image.FromStream(picFileStream)
            picFileStream.Close()
            picFileStream.Dispose()
            .pbx_01_01.Image = Img_Pers
            .pbx_01_01.Show()

        End With

    End Sub


    REM **************************************************************
    REM *  Einfügen von neuen Bildern                                *
    REM **************************************************************
    Public Shared Sub Bild_Insert()

        Call DB_Tab_High("t09_ID", "t09_Bild")
        dbl_Max_ID += 1

        Call Bild_LFD_High()
        int_Max_LFD += 1

        REM *--------------------------------------------------------*
        REM *  Satz in Tabelle t09 (Bilder)                          *
        REM *--------------------------------------------------------*
        str_DBD_t09 = " values ('" + dbl_Max_ID.ToString + "',"
        str_DBD_t09 += "'" + dbl_ID.ToString + "',"
        str_DBD_t09 += "'" + int_Max_LFD.ToString + "',"
        str_DBD_t09 += "'1',"
        str_DBD_t09 += "'" + str_FileName + "',"
        str_DBD_t09 += "'" + NM_Ahnen.tx_01_Bez.Text + "')"

        str_Tab = str_DBS_t09 + str_DBD_t09

        mySelect.Connection = con
        mySelect.CommandText = "insert into t09_Bild " & str_Tab
        Try
            DB_Anz = mySelect.ExecuteNonQuery
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try

        With NM_Ahnen
            .tx_01_LFD.Text = int_Max_LFD.ToString
            .tx_01_Bez.Text = ""
        End With

        If int_Merk_Import = 0 Then
            Call Bild_Aendern_2()
            int_Para_DB = 2
        End If

    End Sub

    REM **************************************************************
    REM *  Ändern von Datumsart-Typen (Textbezeichnung)              *
    REM **************************************************************
    Public Shared Sub Bild_Update()

        Dim reader As OleDbDataReader
        dbl_x = 0

        str_Where = "t09_FK_t01 = " + dbl_ID.ToString
        str_Where += " and t09_lfd = " + NM_Ahnen.tx_01_LFD.Text + " and t09_Typ = 1"

        mySelect.Connection = con
        mySelect.CommandText = "select * from t09_Bild where " & str_Where

        Try
            reader = mySelect.ExecuteReader
            Do While reader.Read
                myNull = IsDBNull(reader.Item("t09_ID"))
                If myNull = False Then dbl_x = reader.Item("t09_ID")
            Loop
            reader.Close()
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try

        str_Tab = "t09_Text = '" + NM_Ahnen.tx_01_Bez.Text + "'"
        mySelect.CommandText = "update t09_Bild set " & str_Tab & " where t09_ID = " & dbl_x.ToString
        Try
            DB_Anz = mySelect.ExecuteNonQuery
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try


    End Sub

    REM ******************************************************************
    REM *  Löschen eines Bildeintrages                                   *
    REM ******************************************************************
    Public Shared Sub Bild_Delete()

        str_Where = "t09_FK_t01 = " + dbl_ID.ToString
        str_Where += " and t09_lfd = " + NM_Ahnen.tx_01_LFD.Text
        Dim int_PicNr As Integer = Val(NM_Ahnen.tx_01_LFD.Text)
        Dim int_PicNrNeu As Integer
        Dim reader As OleDbDataReader
        dbl_x = 0

        mySelect.Connection = con
        mySelect.CommandText = "delete * from t09_Bild where " & str_Where
        Try
            DB_Anz = mySelect.ExecuteNonQuery
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try

        Call Bild_LFD_High()
        If int_Max_LFD > int_PicNr Then
            int_PicNr += 1
            For i10 = int_PicNr To int_Max_LFD
                str_Where = "t09_FK_t01 = " + dbl_ID.ToString
                str_Where += " and t09_lfd = " + i10.ToString
                str_Where += " and t09_Typ = 1"

                mySelect.Connection = con
                mySelect.CommandText = "select * from t09_Bild where " & str_Where

                Try
                    reader = mySelect.ExecuteReader
                    Do While reader.Read
                        myNull = IsDBNull(reader.Item("t09_ID"))
                        If myNull = False Then dbl_x = reader.Item("t09_ID")
                    Loop
                    reader.Close()
                Catch ex As Exception
                    MsgBox(ex.Message)
                End Try

                int_PicNrNeu = i10 - 1
                str_Tab = "t09_lfd = " + int_PicNrNeu.ToString
                mySelect.CommandText = "update t09_Bild set " & str_Tab & " where t09_ID = " & dbl_x.ToString + " and t09_Typ = 1"
                Try
                    DB_Anz = mySelect.ExecuteNonQuery
                Catch ex As Exception
                    MsgBox(ex.Message)
                End Try

            Next
        End If

    End Sub

    REM ******************************************************************
    REM *  Select auf T01 (höchste laufende Nr von ID)                   *
    REM ******************************************************************
    Public Shared Sub Bild_LFD_High()

        mySelect.Connection = con
        mySelect.CommandText = "Select MAX(t09_LFD) from t09_Bild where t09_FK_t01 = " + dbl_ID.ToString
        myAdapter.SelectCommand = mySelect

        Try
            int_Max_LFD = mySelect.ExecuteScalar
        Catch ex As Exception
            int_Max_LFD = 0
        End Try

    End Sub

    REM **************************************************************
    REM *  Prüfen File auf Vorhandensein                             *
    REM **************************************************************
    Public Shared Sub Datei_Exists()

        Dim i11 As Integer
        Dim i12 As Integer

        If File.Exists(str_Path_2) Then
            i11 = Len(str_FileName)
            For i12 = i11 To 0 Step -1
                If Mid(str_FileName, i12, 1) = "." Then
                    str_DateiEndung = Mid(str_FileName, i12 + 1, i11 - i12)
                    str_FileName = Mid(str_FileName, 1, i12 - 1)
                    Call Datei_Exists_Neu()
                    If int_Merk_Bild = 1 Then
                        Exit Sub
                    End If
                End If
            Next
        End If

    End Sub

    REM **************************************************************
    REM *  Dateinamen um Zähler erweitern                            *
    REM **************************************************************
    Public Shared Sub Datei_Exists_Neu()
        Dim i13 As Integer
        Dim str_FN As String
        int_Merk_Bild = 0
        int_PicZaehl = 1

        For i13 = 1 To 999
            str_FN = str_FileName + "_" + i13.ToString("000")
            str_Path_2 = str_PicDirectory + str_FN + "." + str_DateiEndung
            If Not File.Exists(str_Path_2) Then
                int_Merk_Bild = 1
                Exit Sub
            End If
        Next

    End Sub

End Class
