﻿Imports System.Data.OleDb
Imports NM_Ahnen.cls_00_Def
Imports NM_Ahnen.cls_02_DB
Imports NM_Ahnen.cls_04_Util
Imports NM_Ahnen.Cls_90_Mask_201
Public Class Cls_91_DB_Para

    REM ***********************************************************
    REM *  Definition der Datumsarten                             *
    REM *  Laden in DataGrid                                      *
    REM ***********************************************************
    Public Shared Sub Para_Datum_Load()

        Dim int_i5 As Integer
        With NM_Ahnen_Para
            .dgv_Datum.Rows.Clear()
            For int_i5 = 1 To int_AnzPara
                .dgv_Datum.Rows.Add(int_i5.ToString, str_Para_DA(int_i5))
            Next
        End With

    End Sub

    REM ***********************************************************
    REM *  Neuanlage einer Datumsart                              *
    REM ***********************************************************
    Public Shared Sub Para_Datum_Neu()
        With NM_Ahnen_Para
            int_AnzPara += 1
            .tx_201_Text.Text = ""
        End With
    End Sub

    REM ***********************************************************
    REM *  Ändern einer bestehenden Datumsart                     *
    REM ***********************************************************
    Public Shared Sub Para_Datum_Update()
        With NM_Ahnen_Para
            .tx_201_Text.Text = .dgv_Datum.CurrentRow.Cells(1).Value
        End With
    End Sub

    REM **************************************************************
    REM *  Einfügen von neuen Datumsart-Typen                        *
    REM **************************************************************
    Public Shared Sub Para_Datum_DB_Insert()
        Dim int_a01_Typ As Integer = 1
        Call DB_Tab_High("a01_ID", "a01_Para")
        dbl_Max_ID += 1
        REM *--------------------------------------------------------*
        REM *  Satz in Tabelle a01 anlegen (Datumsart)               *
        REM *--------------------------------------------------------*
        NM_Ahnen_Para.tx_201_Text.Text = DB_ZeichenString(NM_Ahnen_Para.tx_201_Text.Text)
        str_DBD_a01 = " values ('" + dbl_Max_ID.ToString + "',"
        str_DBD_a01 += "'" + int_a01_Typ.ToString + "',"
        str_DBD_a01 += "'" + int_AnzPara.ToString + "',"
        str_DBD_a01 += "'" + NM_Ahnen_Para.tx_201_Text.Text + "')"

        str_Tab = str_DBS_a01 + str_DBD_a01

        mySelect.CommandText = "insert into a01_Para " & str_Tab
        Call DB_Execute()
        Call Tab_Datumsart()
        Call Para_Datum_Load()
    End Sub

    REM **************************************************************
    REM *  Ändern von Datumsart-Typen (Textbezeichnung)              *
    REM **************************************************************
    Public Shared Sub Para_Datum_DB_Update()

        Dim reader As OleDbDataReader
        Dim int_a01_Typ As Integer = 1

        str_Where = "a01_Typ = " + int_a01_Typ.ToString
        'str_Where += " and a01_lfd = " + NM_Ahnen_Para.tx_201_LfdNr.Text
        mySelect.CommandText = "select * from a01_Para where " & str_Where

        Try
            reader = mySelect.ExecuteReader
            Do While reader.Read
                myNull = IsDBNull(reader.Item("a01_ID"))
                If myNull = False Then dbl_x = reader.Item("a01_ID")
            Loop
            reader.Close()
        Catch ex As Exception

        End Try

        str_Tab = "a01_Text = '" + NM_Ahnen_Para.tx_201_Text.Text + "'"
        mySelect.CommandText = "update a01_Para set " & str_Tab & " where a01_ID = " & dbl_x.ToString
        Call DB_Execute()
        Call Tab_Datumsart()
        Call Para_Datum_Load()

    End Sub

    REM ****************************************************************
    REM *  Parameterdaten Altersgrenzen für Plausi                     *
    REM ****************************************************************
    Public Shared Sub Para_Altersgrenzen_Load()

        With NM_Ahnen_Para
            .tx_202_Vater_Min.Text = int_Delta_Vater_Min.ToString
            .tx_202_Vater_Max.Text = int_Delta_Vater_Max.ToString
            .tx_202_Mutter_Min.Text = int_Delta_Mutter_Min.ToString
            .tx_202_Mutter_Max.Text = int_Delta_Mutter_Max.ToString
            .tx_202_Ehe_Min.Text = int_Delta_Ehe_Min.ToString
            .tx_202_Ehe_Max.Text = int_Delta_Ehe_Max.ToString
            .tx_202_Pate_Min.Text = int_Delta_Pate_Min.ToString
            .tx_202_Pate_Max.Text = int_Delta_Pate_Max.ToString
            .tx_202_Zeuge_Min.Text = int_Delta_Zeuge_Min.ToString
            .tx_202_Zeuge_Max.Text = int_Delta_Zeuge_Max.ToString
        End With
    End Sub

    REM ****************************************************************
    REM *  Parameterdaten Altersgrenzen für Plausi                     *
    REM ****************************************************************
    Public Shared Sub Para_Altersgrenzen_Neu()
        With NM_Ahnen_Para
            int_Delta_Vater_Min = Val(.tx_202_Vater_Min.Text)
            int_Delta_Vater_Max = Val(.tx_202_Vater_Max.Text)
            int_Delta_Mutter_Min = Val(.tx_202_Mutter_Min.Text)
            int_Delta_Mutter_Max = Val(.tx_202_Mutter_Max.Text)
            int_Delta_Ehe_Min = Val(.tx_202_Ehe_Min.Text)
            int_Delta_Ehe_Max = Val(.tx_202_Ehe_Max.Text)
            int_Delta_Pate_Min = Val(.tx_202_Pate_Min.Text)
            int_Delta_Pate_Max = Val(.tx_202_Pate_Max.Text)
            int_Delta_Zeuge_Min = Val(.tx_202_Zeuge_Min.Text)
            int_Delta_Zeuge_Max = Val(.tx_202_Zeuge_Max.Text)
        End With
    End Sub

    REM **************************************************************
    REM *  Ändern von Datumsart-Typen (Textbezeichnung)              *
    REM **************************************************************
    Public Shared Sub Para_Altersgrenze_DB_Update()

        dbl_x = 1

        Call Para_Altersgrenzen_Neu()

        str_Tab = ""
        str_Tab += "a02_Vater_Min = '" + int_Delta_Vater_Min.ToString + "', "
        str_Tab += "a02_Vater_Max = '" + int_Delta_Vater_Max.ToString + "', "
        str_Tab += "a02_Mutter_Min = '" + int_Delta_Mutter_Min.ToString + "', "
        str_Tab += "a02_Mutter_Max = '" + int_Delta_Mutter_Max.ToString + "', "
        str_Tab += "a02_Ehe_Min = '" + int_Delta_Ehe_Min.ToString + "', "
        str_Tab += "a02_Ehe_Max = '" + int_Delta_Ehe_Max.ToString + "', "
        str_Tab += "a02_Pate_Min = '" + int_Delta_Pate_Min.ToString + "', "
        str_Tab += "a02_Pate_Max = '" + int_Delta_Pate_Max.ToString + "', "
        str_Tab += "a02_Zeuge_Min = '" + int_Delta_Zeuge_Min.ToString + "', "
        str_Tab += "a02_Zeuge_Max = '" + int_Delta_Zeuge_Max.ToString + "'"

        mySelect.CommandText = "update a02_Altersgrenzen set " & str_Tab & " where a02_ID = " & dbl_x.ToString
        Call DB_Execute()

    End Sub

    REM ******************************************************************
    REM *  Parameterdaten für Konfessionsbezeichnungen                   *
    REM ******************************************************************
    Public Shared Sub Para_Konf_Load()

        Dim int_i5 As Integer
        With NM_Ahnen_Para
            .dgv_Konf.Columns(1).SortMode = DataGridViewColumnSortMode.Automatic
            .dgv_Konf.Rows.Clear()
            For int_i5 = 1 To int_AnzKonf
                .dgv_Konf.Rows.Add(int_i5.ToString, str_Para_Konf_Bez(int_i5), str_Para_Konf_Text(int_i5))
            Next
            .dgv_Konf.Columns(1).SortMode = DataGridViewColumnSortMode.Automatic
        End With

    End Sub

    REM ****************************************************************
    REM *  Felder für Neuanlage leeren                                 *
    REM ****************************************************************
    Public Shared Sub Para_Konf_Neu()

        With NM_Ahnen_Para
            int_AnzKonf += 1
            .tx_203_TextKurz.Text = ""
            .tx_203_TextLang.Text = ""
        End With

    End Sub

    REM ****************************************************************
    REM *  Felder für Änderung füllen                                  *
    REM ****************************************************************
    Public Shared Sub Para_Konf_Update()

        With NM_Ahnen_Para
            .tx_203_TextKurz.Text = .dgv_Konf.CurrentRow.Cells(1).Value
            .tx_203_TextLang.Text = .dgv_Konf.CurrentRow.Cells(2).Value
        End With

    End Sub

    REM **************************************************************
    REM *  Einfügen von neuen Konfeesionsarten                       *
    REM **************************************************************
    Public Shared Sub Para_Konf_DB_Insert()

        Dim int_a03_Typ As Integer = 1
        Call DB_Tab_High("a03_ID", "a03_Konfessionen")
        dbl_Max_ID += 1

        REM *--------------------------------------------------------*
        REM *  Satz in Tabelle a03 anlegen (Datumsart)               *
        REM *--------------------------------------------------------*
        NM_Ahnen_Para.tx_203_TextKurz.Text = DB_ZeichenString(NM_Ahnen_Para.tx_203_TextKurz.Text)
        NM_Ahnen_Para.tx_203_TextLang.Text = DB_ZeichenString(NM_Ahnen_Para.tx_203_TextLang.Text)
        str_DBD_a03 = " values ('" + dbl_Max_ID.ToString + "',"
        str_DBD_a03 += "'" + int_a03_Typ.ToString + "',"
        str_DBD_a03 += "'" + int_AnzKonf.ToString + "',"
        str_DBD_a03 += "'" + NM_Ahnen_Para.tx_203_TextKurz.Text + "',"
        str_DBD_a03 += "'" + NM_Ahnen_Para.tx_203_TextLang.Text + "')"

        str_Tab = str_DBS_a03 + str_DBD_a03

        mySelect.CommandText = "insert into a03_Konfessionen " & str_Tab
        Call DB_Execute()
        Call Tab_Konfessionen()
        Call Para_Konf_Load()

    End Sub

    REM **************************************************************
    REM *  Ändern von Konfessionen-Typen (Textbezeichnung)           *
    REM **************************************************************
    Public Shared Sub Para_Konf_DB_Update()

        Dim reader As OleDbDataReader
        Dim int_a03_Typ As Integer = 1
        dbl_x = 0

        str_Where = "a03_Typ = " + int_a03_Typ.ToString
        'str_Where += " and a03_lfd = " + NM_Ahnen_Para.tx_203_LfdNr.Text

        mySelect.CommandText = "select * from a03_Konfessionen where " & str_Where

        Try
            reader = mySelect.ExecuteReader
            Do While reader.Read
                myNull = IsDBNull(reader.Item("a03_ID"))
                If myNull = False Then dbl_x = reader.Item("a03_ID")
            Loop
            reader.Close()
        Catch ex As Exception

        End Try

        str_Tab = "a03_Kurz = '" + NM_Ahnen_Para.tx_203_TextKurz.Text + "',"
        str_Tab = "a03_Lang = '" + NM_Ahnen_Para.tx_203_TextLang.Text + "'"
        mySelect.CommandText = "update a03_Konfessionen set " & str_Tab & " where a03_ID = " & dbl_x.ToString
        Call DB_Execute()
        Call Tab_Datumsart()
        Call Para_Datum_Load()
    End Sub

    REM ***********************************************************
    REM *  Parameterdaten für Ortsbezeichnungen                   *
    REM ***********************************************************
    Public Shared Sub Para_Orte_Load()

        Dim int_i5 As Integer
        With NM_Ahnen_Para
            .dgv_Ort.Rows.Clear()
            For int_i5 = 1 To int_AnzOrte
                .dgv_Ort.Rows.Add(int_i5.ToString("0000"), str_Para_Ort1_Bez(int_i5), str_Para_Ort2_Bez(int_i5), str_Para_Ort3_Bez(int_i5))
            Next
            .dgv_Ort.Columns(1).SortMode = DataGridViewColumnSortMode.Automatic
        End With

    End Sub

    REM ***********************************************************
    REM *  Felder für Neuerfassung leeren                         *
    REM ***********************************************************
    Public Shared Sub Para_Orte_Neu()

        With NM_Ahnen_Para
            int_AnzOrte += 1
            .tx_205_LfdNr.Text = int_AnzOrte
            .tx_205_Ort1.Text = ""
            .tx_205_Ort2.Text = ""
            .tx_205_Ort3.Text = ""
        End With

    End Sub

    REM **************************************************************
    REM *  Einfügen von neuen Orten                                  *
    REM **************************************************************
    Public Shared Sub Para_Orte_DB_Insert()

        Dim int_a04_Typ As Integer = 1
        Call DB_Tab_High("a04_ID", "a04_Orte")
        dbl_Max_ID += 1

        REM *--------------------------------------------------------*
        REM *  Satz in Tabelle a04 anlegen (Orte)                    *
        REM *--------------------------------------------------------*
        NM_Ahnen_Para.tx_205_Ort1.Text = DB_ZeichenString(NM_Ahnen_Para.tx_205_Ort1.Text)
        NM_Ahnen_Para.tx_205_Ort2.Text = DB_ZeichenString(NM_Ahnen_Para.tx_205_Ort2.Text)
        NM_Ahnen_Para.tx_205_Ort3.Text = DB_ZeichenString(NM_Ahnen_Para.tx_205_Ort3.Text)
        str_DBD_a04 = " values ('" + dbl_Max_ID.ToString + "',"
        str_DBD_a04 += "'" + int_a04_Typ.ToString + "',"
        str_DBD_a04 += "'" + int_AnzOrte.ToString + "',"
        str_DBD_a04 += "'" + NM_Ahnen_Para.tx_205_Ort1.Text + "', "
        str_DBD_a04 += "'" + NM_Ahnen_Para.tx_205_Ort2.Text + "', "
        str_DBD_a04 += "'" + NM_Ahnen_Para.tx_205_Ort3.Text + "')"
        str_Tab = str_DBS_a04 + str_DBD_a04

        mySelect.CommandText = "insert into a04_Orte " & str_Tab
        Call DB_Execute()
        Call Tab_Orte()
        Call Para_Orte_Load()
    End Sub

    REM ***************************************************************
    REM *  Update bestehender Ortsbezeichnungen                       *
    REM ***************************************************************
    Public Shared Sub Para_Orte_Update()
        Dim reader As OleDbDataReader
        Dim int_i88 As Integer
        With NM_Ahnen_Para

            .tx_205_LfdNr.Text = .dgv_Ort.CurrentRow.Cells(0).Value
            .tx_205_Ort1.Text = .dgv_Ort.CurrentRow.Cells(1).Value
            .tx_205_Ort2.Text = .dgv_Ort.CurrentRow.Cells(2).Value
            .tx_205_Ort3.Text = .dgv_Ort.CurrentRow.Cells(3).Value
            For int_i88 = 0 To int_Anz_Ort
                If .tx_205_Ort1.Text = str_Para_Ort1_Bez(int_i88) Then
                    dbl_x = int_Para_Ort_Nr(int_i88)
                    Exit For
                End If
            Next
        End With

        str_Where = "a04_ID = " + dbl_x.ToString
        mySelect.CommandText = "select * from a04_Orte where " & str_Where
        Try
            reader = mySelect.ExecuteReader
            Do While reader.Read
                myNull = IsDBNull(reader.Item("a04_ID"))
                If myNull = False Then dbl_x = reader.Item("a04_ID")
            Loop
            reader.Close()
        Catch ex As Exception

        End Try

    End Sub

    REM **************************************************************
    REM *  Ändern von Ortsbezeichnungen                              *
    REM **************************************************************
    Public Shared Sub Para_Orte_Update2()

        NM_Ahnen_Para.tx_205_Ort1.Text = DB_ZeichenString(NM_Ahnen_Para.tx_205_Ort1.Text)
        NM_Ahnen_Para.tx_205_Ort2.Text = DB_ZeichenString(NM_Ahnen_Para.tx_205_Ort2.Text)
        NM_Ahnen_Para.tx_205_Ort3.Text = DB_ZeichenString(NM_Ahnen_Para.tx_205_Ort3.Text)
        str_Tab = "a04_Ort1 = '" + NM_Ahnen_Para.tx_205_Ort1.Text + "',"
        str_Tab = "a04_Ort2 = '" + NM_Ahnen_Para.tx_205_Ort2.Text + "',"
        str_Tab = "a04_Ort3 = '" + NM_Ahnen_Para.tx_205_Ort3.Text + "'"
        mySelect.CommandText = "update a04_Orte set " & str_Tab & " where a04_ID = " & dbl_x.ToString
        Call DB_Execute()
        Call Tab_Orte()
        Call Para_Orte_Load()

    End Sub

    REM **************************************************************
    REM *  Einfügen von neuen Orten                                  *
    REM **************************************************************
    Public Shared Sub Para_Orte_DB_Insert_Auto()

        Dim int_a04_Typ As Integer = 1
        If int_Merk_Orte1 = 0 Then Call DB_Tab_High("a04_ID", "a04_Orte")
        dbl_Max_ID += 1
        int_AnzOrte += 1

        REM *--------------------------------------------------------*
        REM *  Satz in Tabelle a04 anlegen (Orte)                    *
        REM *--------------------------------------------------------*
        str_TX_Ort1 = DB_ZeichenString(str_TX_Ort1)
        str_TX_Ort2 = DB_ZeichenString(str_TX_Ort2)
        str_TX_Ort3 = DB_ZeichenString(str_TX_Ort3)
        str_DBD_a04 = " values ('" + dbl_Max_ID.ToString + "',"
        str_DBD_a04 += "'" + int_a04_Typ.ToString + "',"
        str_DBD_a04 += "'" + int_AnzOrte.ToString + "',"
        str_DBD_a04 += "'" + str_TX_Ort1 + "', "
        str_DBD_a04 += "'" + str_TX_Ort2 + "', "
        str_DBD_a04 += "'" + str_TX_Ort3 + "')"

        str_Tab = str_DBS_a04 + str_DBD_a04

        mySelect.CommandText = "insert into a04_Orte " & str_Tab
        Call DB_Execute()
        Call Tab_Orte()

    End Sub

    REM ******************************************************************
    REM *  Ortstabelle gesamt neu aufbauen                               *
    REM ******************************************************************
    Public Shared Sub Para_Orte_Aufbau()

        Dim int_Anz As Integer = GetNumberOfRecords(con, "t01_Person")
        Dim str_O1 As String
        Dim str_O2 As String
        Dim reader As OleDbDataReader
        ReDim str_Tab_Orte(int_Anz * 2)
        int_Anz_Ort = 1

        REM *------------------------------------------------------------*
        REM *  Einlesen der Tabelle t01 (Geburts- und Sterbeorte)        *
        REM *------------------------------------------------------------*
        mySelect.CommandText = "select * from t01_Person"
        reader = mySelect.ExecuteReader

        Do While reader.Read()
            str_O1 = ""
            str_O2 = ""
            myNull = IsDBNull(reader.Item("t01_GOrt"))
            If myNull = False Then str_O1 = reader.Item("t01_GOrt")
            myNull = IsDBNull(reader.Item("t01_SOrt"))
            If myNull = False Then str_O2 = reader.Item("t01_SOrt")

            str_O1 = Trim(str_O1)
            str_O2 = Trim(str_O2)
            If str_O1 > "" Then Call Para_Orte_Tabelle(str_O1)
            If str_O2 > "" Then Call Para_Orte_Tabelle(str_O2)
        Loop
        reader.Close()

        REM *------------------------------------------------------------*
        REM *  Einlesen der Tabelle t02 (Tauf- und Firmorte)             *
        REM *------------------------------------------------------------*
        mySelect.CommandText = "select * from t02_Taufe"
        reader = mySelect.ExecuteReader

        Do While reader.Read()
            str_O1 = ""
            str_O2 = ""
            myNull = IsDBNull(reader.Item("t02_TOrt"))
            If myNull = False Then str_O1 = reader.Item("t02_TOrt")
            myNull = IsDBNull(reader.Item("t02_FOrt"))
            If myNull = False Then str_O1 = reader.Item("t02_FOrt")

            str_O1 = Trim(str_O1)
            str_O2 = Trim(str_O2)
            If str_O1 > "" Then Call Para_Orte_Tabelle(str_O1)
            If str_O2 > "" Then Call Para_Orte_Tabelle(str_O2)
        Loop
        reader.Close()

        REM *------------------------------------------------------------*
        REM *  Einlesen der Tabelle t03 (Beerdigungsorte)                *
        REM *------------------------------------------------------------*
        mySelect.CommandText = "select * from t03_Beerd"
        reader = mySelect.ExecuteReader

        Do While reader.Read()
            str_O1 = ""
            myNull = IsDBNull(reader.Item("t03_BOrt"))
            If myNull = False Then str_O1 = reader.Item("t03_BOrt")

            str_O1 = Trim(str_O1)
            If str_O1 > "" Then Call Para_Orte_Tabelle(str_O1)
        Loop
        reader.Close()

        REM *------------------------------------------------------------*
        REM *  Einlesen der Tabelle t041 (Eheorte)                       *
        REM *------------------------------------------------------------*
        mySelect.CommandText = "select * from t041_Ehedaten"
        reader = mySelect.ExecuteReader

        Do While reader.Read()
            str_O1 = ""
            str_O2 = ""
            myNull = IsDBNull(reader.Item("t041_Ort1"))
            If myNull = False Then str_O1 = reader.Item("t041_Ort1")
            myNull = IsDBNull(reader.Item("t041_Ort2"))
            If myNull = False Then str_O2 = reader.Item("t041_Ort2")

            str_O1 = Trim(str_O1)
            str_O2 = Trim(str_O2)
            If str_O1 > "" Then Call Para_Orte_Tabelle(str_O1)
            If str_O2 > "" Then Call Para_Orte_Tabelle(str_O2)
        Loop
        reader.Close()

        REM *------------------------------------------------------------*
        REM *  Tabelle löschen, wird neu aufgebaut                       *
        REM *------------------------------------------------------------*
        mySelect.CommandText = "delete * from a04_Orte"
        Call DB_Execute()
        Call Para_Orte_Insert()

        REM *------------------------------------------------------------*
        REM *  Tabelle neu füllen                                        *
        REM *------------------------------------------------------------*
        int_AnzOrte = 0
        dbl_a04_ID = 0
        Call Para_Orte_DB_Insert()

        Call Tab_Orte()
        Call Para_Orte_Load()

    End Sub

    REM **************************************************************
    REM *  Füllen der Listview für Orte                              *
    REM **************************************************************
    Public Shared Sub Para_Orte_Tabelle(ByVal str_H As String)

        Dim int_Vorhanden As Integer = 0
        str_TX_Ort2 = ""
        str_TX_Ort3 = ""
        str_H = LTrim(str_H)
        str_H = RTrim(str_H)

        If int_Anz_Ort = 1 Then
            str_Tab_Orte(1) = str_H
            int_Anz_Ort += 1
        End If
        For int_i09 = 1 To int_Anz_Ort - 1
            If str_Tab_Orte(int_i09) = str_H Then
                int_Vorhanden = 1
                Exit For
            End If
        Next

        If int_Vorhanden = 0 Then
            str_Tab_Orte(int_Anz_Ort) = str_H
            int_Anz_Ort += 1
        End If

    End Sub

    REM **************************************************************
    REM *  Einfügen von neuen Orten                                  *
    REM **************************************************************
    Public Shared Sub Para_Orte_Insert()

        Dim int_a04_Typ As Integer = 1
        Dim int_zz As Integer = 0
        int_AnzOrte = 0
        If int_Merk_Orte1 = 0 Then Call DB_Tab_High("a04_ID", "a04_Orte")

        For int_zz = 1 To int_Anz_Ort

            dbl_Max_ID += 1
            int_AnzOrte += 1

            REM *--------------------------------------------------------*
            REM *  Satz in Tabelle a04 anlegen (Orte)                    *
            REM *--------------------------------------------------------*
            str_Tab_Orte(int_zz) = DB_ZeichenString(str_Tab_Orte(int_zz))
            str_TX_Ort2 = DB_ZeichenString(str_TX_Ort2)
            str_TX_Ort3 = DB_ZeichenString(str_TX_Ort3)
            str_DBD_a04 = " values ('" + dbl_Max_ID.ToString + "',"
            str_DBD_a04 += "'" + int_a04_Typ.ToString + "',"
            str_DBD_a04 += "'" + int_AnzOrte.ToString + "',"
            str_DBD_a04 += "'" + str_Tab_Orte(int_zz) + "', "
            str_DBD_a04 += "'" + str_TX_Ort2 + "', "
            str_DBD_a04 += "'" + str_TX_Ort3 + "')"
            str_Tab = str_DBS_a04 + str_DBD_a04

            mySelect.CommandText = "insert into a04_Orte " & str_Tab
            Call DB_Execute()

        Next

    End Sub

    REM **************************************************************
    REM *  Namensbezeichungen in DataGrid übertragen                 *
    REM **************************************************************
    Public Shared Sub Para_Namen_Load()
        Dim int_i5 As Integer
        int_AnzNam1 = GetNumberOfRecordsTyp(con, "a07_Namen", " where a07_Typ = 1")

        With NM_Ahnen_Para
            .dgv_Name.Columns(1).SortMode = DataGridViewColumnSortMode.Automatic
            .dgv_Name.Rows.Clear()
            For int_i5 = 1 To int_AnzNam1
                .dgv_Name.Rows.Add(int_i5.ToString("0000"), str_Para_Nam1_Text(int_i5))
            Next
            .dgv_Name.Columns(1).SortMode = DataGridViewColumnSortMode.Automatic

        End With
    End Sub

    REM **************************************************************
    REM *  Maskenfelder für Neuanlage leeren                         *
    REM **************************************************************
    Public Shared Sub Para_Namen_Neu()
        With NM_Ahnen_Para
            int_AnzNam1 += 1
            .tx_204_Bez.Text = ""
        End With
    End Sub

    REM ***************************************************************
    REM *  Neuen Eintrag in DB eintragen                              *
    REM ***************************************************************
    Public Shared Sub Para_Namen_Insert()
        Dim int_a07_Typ As Integer = 1
        Call DB_Tab_High("a07_ID", "a07_Namen")
        dbl_Max_ID += 1
        NM_Ahnen_Para.tx_204_Bez.Text = DB_ZeichenString(NM_Ahnen_Para.tx_204_Bez.Text)

        str_DBD_a07 = " values ('" + dbl_Max_ID.ToString + "'"
        str_DBD_a07 += "'" + int_a07_Typ.ToString + "',"
        str_DBD_a07 += "'" + int_AnzNam1.ToString + "',"
        str_DBD_a07 += "'" + NM_Ahnen_Para.tx_204_Bez.Text + "')"

        str_Tab = str_DBS_a07 + str_DBD_a07
        mySelect.CommandText = "insert into a07_Namen " & str_Tab
        Call DB_Execute()

        Call Tab_Namen()
        Call Para_Namen_Load()

    End Sub

    REM *****************************************************************
    REM *  Änderung in Datenbank übertragen                             *
    REM *****************************************************************
    Public Shared Sub Para_Namen_Update()
        Dim reader As OleDbDataReader
        Dim int_a07_Typ As Integer = 1
        Dim int_i88 As Integer

        With NM_Ahnen_Para
            .tx_204_Bez.Text = .dgv_Name.CurrentRow.Cells(1).Value
            For int_i88 = 0 To int_AnzNam1
                If .tx_204_Bez.Text = str_Para_Nam1_Text(int_i88) Then
                    dbl_x = int_Para_Nam1_Nr(int_i88)
                    Exit For
                End If
            Next
        End With

        str_Where = "a07_Typ = " + int_a07_Typ.ToString
        str_Where += " and a07_lfd = " + dbl_x.ToString

        mySelect.CommandText = "select * from a07_Namen where " & str_Where
        Try
            reader = mySelect.ExecuteReader
            Do While reader.Read
                myNull = IsDBNull(reader.Item("a07_ID"))
                If myNull = False Then dbl_x = reader.Item("a01_ID")
            Loop
            reader.Close()
        Catch ex As Exception

        End Try
    End Sub

    REM ***********************************************************
    REM *  Update ausführen                                       *
    REM ***********************************************************
    Public Shared Sub Para_Namen_Update2()
        str_Tab = "a07_Text = '" + NM_Ahnen_Para.tx_204_Bez.Text + "'"
        mySelect.CommandText = "update a07_Namen set " & str_Tab & " where a07_ID = " & dbl_x.ToString
        Call DB_Execute()
        Call Tab_Namen()
        Call Para_Namen_Load()

    End Sub

    REM *************************************************************
    REM *  Namenstabelle komplett neu aufbauen                      *
    REM *************************************************************
    Public Shared Sub Para_Namen_Aufbau()
        Dim int_Anz As Integer = GetNumberOfRecords(con, "t01_Person")
        Dim str_N1 As String
        Dim str_N2 As String
        Dim str_N3 As String
        Dim str_N4 As String
        Dim str_N5 As String
        Dim reader As OleDbDataReader
        ReDim str_Tab_Orte(int_Anz * 2)
        ReDim int_Tab_Orte(int_Anz * 2)
        int_Anz_Ort = 1

        REM *  alte Werte löschen
        mySelect.CommandText = "delete * from a07_Namen"
        Call DB_Execute()

        mySelect.CommandText = "select * from t01_Person"
        reader = mySelect.ExecuteReader
        Do While reader.Read
            str_N1 = ""
            str_N2 = ""
            str_N3 = ""
            str_N4 = ""
            str_N5 = ""
            myNull = IsDBNull(reader.Item("t01_Name"))
            If myNull = False Then str_N1 = reader.Item("t01_Name")
            myNull = IsDBNull(reader.Item("t01_GebName"))
            If myNull = False Then str_N2 = reader.Item("t01_GebName")
            myNull = IsDBNull(reader.Item("t01_NameZ"))
            If myNull = False Then str_N3 = reader.Item("t01_NameZ")
            myNull = IsDBNull(reader.Item("t01_RufName"))
            If myNull = False Then str_N4 = reader.Item("t01_RufName")
            myNull = IsDBNull(reader.Item("t01_Vorname"))
            If myNull = False Then str_N5 = reader.Item("t01_Vorname")
            str_N1 = Trim(str_N1)
            str_N2 = Trim(str_N2)
            str_N3 = Trim(str_N3)
            str_N4 = Trim(str_N4)
            str_N5 = Trim(str_N5)

            If str_N1 > "" Then Call Para_Namen_Tabelle(str_N1, 1)
            If str_N2 > "" Then Call Para_Namen_Tabelle(str_N2, 1)
            If str_N3 > "" Then Call Para_Namen_Tabelle(str_N3, 1)
            If str_N4 > "" Then Call Para_Namen_Tabelle(str_N4, 2)
            If str_N5 > "" Then Call Para_Namen_Tabelle(str_N5, 2)

        Loop
        reader.Close()
        Call Para_Namen_Aufbau_Insert()

    End Sub

    REM ***********************************************************
    REM *  Daten in Tabelle sammeln                               *
    REM ***********************************************************
    Public Shared Sub Para_Namen_Tabelle(ByVal str_NX As String, ByVal int_Typ As Integer)

        Dim i88 As Integer
        For i88 = 1 To int_Anz_Ort - 1
            If str_Tab_Orte(i88) = str_NX Then
                Exit Sub
            End If
        Next

        str_Tab_Orte(int_Anz_Ort) = str_NX
        int_Tab_Orte(int_Anz_Ort) = int_Typ
        int_Anz_Ort += 1

    End Sub

    REM ***********************************************************
    REM *  Tabelle in DB übertragen                               *
    REM ***********************************************************
    Public Shared Sub Para_Namen_Aufbau_Insert()
        Dim int_i88 As Integer

        Call DB_Tab_High("a07_ID", "a07_Namen")
        For int_i88 = 1 To int_Anz_Ort - 1
            dbl_Max_ID += 1
            str_Tab_Orte(int_i88) = DB_ZeichenString(str_Tab_Orte(int_i88))

            str_DBD_a07 = " values ('" + dbl_Max_ID.ToString + "',"
            str_DBD_a07 += "'" + int_Tab_Orte(int_i88).ToString + "',"
            str_DBD_a07 += "'" + dbl_Max_ID.ToString + "',"
            str_DBD_a07 += "'" + str_Tab_Orte(int_i88) + "')"

            str_Tab = str_DBS_a07 + str_DBD_a07
            mySelect.CommandText = "insert into a07_Namen " & str_Tab
            Call DB_Execute()
        Next
        Call Tab_Namen()
        Call Para_Namen_Load()
    End Sub

    REM ************************************************************
    REM *  Vornamenwerte in DataGrid übertragen                    *
    REM ************************************************************
    Public Shared Sub Para_Vornamen_Load()
        Dim int_i5 As Integer
        With NM_Ahnen_Para
            .dgv_Vorname.Rows.Clear()
            For int_i5 = 1 To int_AnzNam2
                .dgv_Vorname.Rows.Add(int_i5.ToString("0000"), str_Para_Nam2_Text(int_i5))
            Next
            .dgv_Vorname.Columns(1).SortMode = DataGridViewColumnSortMode.Automatic

        End With
    End Sub

    REM *************************************************************
    REM *  Maske für Neuanlage leeren                               *
    REM *************************************************************
    Public Shared Sub Para_Vornamen_Neu()
        With NM_Ahnen_Para
            int_AnzNam2 += 1
            .tx_206_Bez.Text = ""
        End With
    End Sub

    REM **************************************************************
    REM *  Neuen Eintrag in DB einfügen                              *
    REM **************************************************************
    Public Shared Sub Para_Vornamen_Insert()
        Dim int_a07_Typ As Integer = 2
        Call DB_Tab_High("a07_ID", "a07_Namen")
        dbl_Max_ID += 1

        NM_Ahnen_Para.tx_206_Bez.Text = DB_ZeichenString(NM_Ahnen_Para.tx_206_Bez.Text)
        str_DBD_a07 = " values ('" + dbl_Max_ID.ToString + "'"
        str_DBD_a07 += "'" + int_a07_Typ.ToString + "',"
        str_DBD_a07 += "'" + int_AnzNam1.ToString + "',"
        str_DBD_a07 += "'" + NM_Ahnen_Para.tx_206_Bez.Text + "')"

        str_Tab = str_DBS_a07 + str_DBD_a07
        mySelect.CommandText = "insert into a07_Namen " & str_Tab
        Call DB_Execute()
        Call Tab_Vornamen()
        Call Para_Vornamen_Load()

    End Sub

    REM *********************************************************
    REM *  Eintrag updaten                                      *
    REM *********************************************************
    Public Shared Sub Para_Vornamen_Update()
        Dim reader As OleDbDataReader
        Dim int_a07_Typ As Integer = 2
        Dim int_i88 As Integer

        With NM_Ahnen_Para
            .tx_206_Bez.Text = .dgv_Vorname.CurrentRow.Cells(1).Value
            For int_i88 = 0 To int_AnzNam1
                If .tx_206_Bez.Text = str_Para_Nam2_Text(int_i88) Then
                    dbl_x = int_Para_Nam2_Nr(int_i88)
                    Exit For
                End If
            Next
        End With

        str_Where = "a07_Typ = " + int_a07_Typ.ToString
        str_Where += " and a07_lfd = " + dbl_x.ToString

        mySelect.CommandText = "select * from a07_Namen where " & str_Where
        Try
            reader = mySelect.ExecuteReader
            Do While reader.Read
                myNull = IsDBNull(reader.Item("a07_ID"))
                If myNull = False Then dbl_x = reader.Item("a07_ID")
            Loop
            reader.Close()
        Catch ex As Exception

        End Try
        Call Tab_Vornamen()
        Call Para_Vornamen_Load()
    End Sub

    REM *************************************************************
    REM *  Datensatz update in DB                                   *
    REM *************************************************************
    Public Shared Sub Para_Vornamen_Update2()

        NM_Ahnen_Para.tx_206_Bez.Text = DB_ZeichenString(NM_Ahnen_Para.tx_206_Bez.Text)
        str_Tab = "a07_Text = '" + NM_Ahnen_Para.tx_206_Bez.Text + "'"
        mySelect.CommandText = "update a07_Namen set " & str_Tab & " where a07_ID = " & dbl_x.ToString
        Call DB_Execute()
        Call Tab_Vornamen()
        Call Para_Vornamen_Load()

    End Sub

    REM **************************************************************
    REM *  Daten in GridView übertragen                              *
    REM **************************************************************
    Public Shared Sub Para_Tod_Load()
        Dim int_i5 As Integer
        With NM_Ahnen_Para
            .dgv_Tod.Rows.Clear()
            For int_i5 = 1 To int_AnzTod
                .dgv_Tod.Rows.Add(int_i5.ToString("0000"), str_Para_Tod_Text(int_i5))
            Next
            .dgv_Tod.Columns(1).SortMode = DataGridViewColumnSortMode.Automatic

        End With
    End Sub

    REM ***************************************************************
    REM *  Maskenfelder für Neuanlage leeren                          *
    REM ***************************************************************
    Public Shared Sub Para_Tod_Neu()
        With NM_Ahnen_Para
            int_AnzTod += 1
            .tx_207_Bez.Text = ""
        End With
    End Sub

    REM ***************************************************************
    REM * Datensatz einfügen                                          *
    REM ***************************************************************
    Public Shared Sub Para_Tod_Insert()
        Dim int_a08_Typ As Integer = 1
        Call DB_Tab_High("a08_ID", "a08_Tod")
        dbl_Max_ID += 1
        int_AnzTod += 1

        NM_Ahnen_Para.tx_207_Bez.Text = DB_ZeichenString(NM_Ahnen_Para.tx_207_Bez.Text)
        str_DBD_a08 = " values ('" + dbl_Max_ID.ToString + "',"
        str_DBD_a08 += "'" + int_a08_Typ.ToString + "',"
        str_DBD_a08 += "'" + int_AnzTod.ToString + "',"
        str_DBD_a08 += "'" + NM_Ahnen_Para.tx_207_Bez.Text + "')"

        str_Tab = str_DBS_a08 + str_DBD_a08
        mySelect.CommandText = "insert into a08_Tod " & str_Tab
        Call DB_Execute()
        Call Tab_Tod()
        Call Para_Tod_Load()

    End Sub

    REM ***********************************************************
    REM *  Datensatz updaten                                      *
    REM ***********************************************************
    Public Shared Sub Para_Tod_Update()
        Dim reader As OleDbDataReader
        Dim int_a08_Typ As Integer = 1
        Dim int_i88 As Integer

        With NM_Ahnen_Para
            .tx_207_Bez.Text = .dgv_Tod.CurrentRow.Cells(1).Value
            For int_i88 = 0 To int_AnzTod
                If .tx_207_Bez.Text = str_Para_Tod_Text(int_i88) Then
                    dbl_x = int_Para_Tod_Nr(int_i88)
                    Exit For
                End If
            Next
        End With

        str_Where = "a08_Typ = " + int_a08_Typ.ToString
        str_Where += " and a08_lfd = " + dbl_x.ToString

        mySelect.CommandText = "select * from a08_Tod where " & str_Where
        Try
            reader = mySelect.ExecuteReader
            Do While reader.Read
                myNull = IsDBNull(reader.Item("a08_ID"))
                If myNull = False Then dbl_x = reader.Item("a08_ID")
            Loop
            reader.Close()
        Catch ex As Exception

        End Try

    End Sub

    REM *******************************************************
    REM *  Einfügen in DB                                     *
    REM *******************************************************
    Public Shared Sub Para_Tod_Update2()

        NM_Ahnen_Para.tx_207_Bez.Text = DB_ZeichenString(NM_Ahnen_Para.tx_207_Bez.Text)
        str_Tab = "a08_Text = '" + NM_Ahnen_Para.tx_207_Bez.Text + "'"
        mySelect.CommandText = "update a08_Namen set " & str_Tab & " where a08_ID = " & dbl_x.ToString
        Call DB_Execute()
        Call Tab_Tod()
        Call Para_Tod_Load()

    End Sub

    REM *********************************************************
    REM *  Gesamtbestand neu aufbauen                           *
    REM *********************************************************
    Public Shared Sub Para_Tod_Aufbau()
        Dim int_Anz As Integer = GetNumberOfRecords(con, "t03_Beerd")
        Dim str_N1 As String
        Dim reader As OleDbDataReader
        ReDim str_Tab_Orte(int_Anz)
        int_Anz_Ort = 1

        REM *  alte Werte löschen
        mySelect.CommandText = "delete * from a08_Tod"
        Call DB_Execute()

        mySelect.CommandText = "select * from t03_Beerd"
        reader = mySelect.ExecuteReader
        Do While reader.Read
            str_N1 = ""
            myNull = IsDBNull(reader.Item("t03_Tod_Ursache"))
            If myNull = False Then str_N1 = reader.Item("t03_Tod_Ursache")
            str_N1 = Trim(str_N1)

            If str_N1 > "" Then Call Para_Tod_Tabelle(str_N1)

        Loop
        reader.Close()

        Call Para_Tod_Aufbau_Insert()

    End Sub

    REM *********************************************************
    REM *  Daten in Tabelle sammeln                             *
    REM *********************************************************
    Public Shared Sub Para_Tod_Tabelle(ByVal str_NX As String)

        Dim i88 As Integer
        For i88 = 1 To int_Anz_Ort - 1
            If str_Tab_Orte(i88) = str_NX Then
                Exit Sub
            End If
        Next

        str_Tab_Orte(int_Anz_Ort) = str_NX
        int_Anz_Ort += 1

    End Sub

    REM ***********************************************************
    REM *  Tabelle in DB übertragen                               *
    REM ***********************************************************
    Public Shared Sub Para_Tod_Aufbau_Insert()
        Dim int_i88 As Integer

        Call DB_Tab_High("a08_ID", "a08_Tod")
        For int_i88 = 1 To int_Anz_Ort - 1
            dbl_Max_ID += 1

            str_Tab_Orte(int_i88) = DB_ZeichenString(str_Tab_Orte(int_i88))
            str_DBD_a08 = " values ('" + dbl_Max_ID.ToString + "',"
            str_DBD_a08 += "'1',"
            str_DBD_a08 += "'" + dbl_Max_ID.ToString + "',"
            str_DBD_a08 += "'" + str_Tab_Orte(int_i88) + "')"

            str_Tab = str_DBS_a08 + str_DBD_a08
            mySelect.CommandText = "insert into a08_Tod " & str_Tab
            Call DB_Execute()
        Next
        Call Tab_Tod()
        Call Para_Tod_Load()

    End Sub

    REM **************************************************************
    REM *  Laden der Berufsbezeichnungen ins Data_Grid               *
    REM **************************************************************
    Public Shared Sub Para_Beruf_Load()
        Dim int_i5 As Integer
        With NM_Ahnen_Para
            .dgv_Beruf.Rows.Clear()
            For int_i5 = 1 To int_AnzBeruf
                .dgv_Beruf.Rows.Add(int_i5.ToString("0000"), str_Para_Beruf_Text(int_i5))
            Next
            .dgv_Beruf.Columns(1).SortMode = DataGridViewColumnSortMode.Automatic

        End With
    End Sub


    Public Shared Sub Para_Beruf_Neu()
        With NM_Ahnen_Para
            .bt_200_Neu.Enabled = False
            int_AnzBeruf += 1
            .tx_208_Bez.Text = ""
        End With
    End Sub


    Public Shared Sub Para_Beruf_Insert()
        Call DB_Tab_High("t77_ID", "t77_Beruf")
        dbl_Max_ID += 1
        int_AnzTod += 1

        str_DBD_t77 = " values ('" + dbl_Max_ID.ToString + "',"
        str_DBD_t77 += "'" + NM_Ahnen_Para.tx_208_Bez.Text + "')"

        str_Tab = str_DBS_t77 + str_DBD_t77
        mySelect.CommandText = "insert into t77_Beruf " & str_Tab
        Call DB_Execute()

        Call Tab_Beruf()
        Call Para_Beruf_Load()

    End Sub

    Public Shared Sub Para_Beruf_Update()
        Dim reader As OleDbDataReader
        Dim int_t77_Typ As Integer = 1
        Dim int_i88 As Integer

        With NM_Ahnen_Para
            .tx_208_Bez.Text = .dgv_Beruf.CurrentRow.Cells(1).Value
            For int_i88 = 0 To int_AnzTod
                If .tx_208_Bez.Text = str_Para_Tod_Text(int_i88) Then
                    dbl_x = int_Para_Tod_Nr(int_i88)
                    Exit For
                End If
            Next
        End With

        str_Where = "t77_ID = " + dbl_x.ToString

        mySelect.CommandText = "select * from t77_ID where " & str_Where
        Try
            reader = mySelect.ExecuteReader
            Do While reader.Read
                myNull = IsDBNull(reader.Item("t77_ID"))
                If myNull = False Then dbl_x = reader.Item("t77_ID")
            Loop
            reader.Close()
        Catch ex As Exception

        End Try

    End Sub

    Public Shared Sub Para_Beruf_Update2()
        str_Tab = "t77_Text = '" + NM_Ahnen_Para.tx_208_Bez.Text + "'"
        mySelect.CommandText = "update t77_Beruf set " & str_Tab & " where t77_ID = " & dbl_x.ToString
        Call DB_Execute()
        Call Tab_Beruf()
        Call Para_Beruf_Load()

    End Sub

End Class
